package cokr.xit.fims.nxrp.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.nxrp.A01;
import cokr.xit.fims.nxrp.NisIndivQuery;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 과태료 대장 단속 정보 등록 정보 DAO
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2024-02-16	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("nisA01Mapper")
public interface NisA01Mapper extends AbstractMapper {
	/**지정한 조건에 따라 과태료 대장 단속 정보 등록 목록을 조회하여 반환한다.<br />
	 * @param req 과태료 대장 단속 정보 등록 조회 조건
	 * @return 과태료 대장 단속 정보 등록 목록
	 */
	List<DataObject> selectNisIndivA01List(NisIndivQuery req);

	/**지정한 조건에 따라 과태료 대장 단속 정보 등록 객체들을 반환한다.
	 * @param req 과태료 대장 단속 정보 등록 조회 조건
	 * @return 과태료 대장 단속 정보 등록 객체 목록
	 */
	List<DataObject> selectNisIndivA01s(NisIndivQuery req);

	/**과태료 대장 단속 정보 등록 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"nisIndivA01" - 과태료 대장 단속 정보 등록</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertNisIndivA01(Map<String, Object> params);

	/**과태료 대장 단속 정보 등록 정보를 등록한다.
	 * @param nisIndivA01 과태료 대장 단속 정보 등록
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(A01 nisIndivA01) {
		return nisIndivA01 != null && insertNisIndivA01(params().set("nisIndivA01", nisIndivA01)) == 1;
	}

	/**과태료 대장 단속 정보 등록 정보를 수정한다.
	 * @param params 파라미터
	 * <ul><li>"nisIndivA01" - 과태료 대장 단속 정보 등록</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int updateNisIndivA01(Map<String, Object> params);

	/**과태료 대장 단속 정보 등록 정보를 수정한다.
	 * @param nisIndivA01 과태료 대장 단속 정보 등록
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean update(A01 nisIndivA01) {
		return nisIndivA01 != null && updateNisIndivA01(params().set("nisIndivA01", nisIndivA01)) == 1;
	}

	/**지정한 과태료 대장 단속 정보 등록을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"nisIndivA01" - 과태료 대장 단속 정보 등록</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteNisIndivA01(Map<String, ?> params);

	/**과태료 대장 단속 정보 등록 정보를 삭제한다.
	 * @param nisIndivA01 과태료 대장 단속 정보 등록
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(A01 nisIndivA01) {
		return nisIndivA01 != null && deleteNisIndivA01(params().set("nisIndivA01", nisIndivA01)) == 1;
	}

	/**단속 ID에 해당하는 단속, 납부자 객체를 반환한다.
	 * @param params 파라미터
	 * <ul><li>crdnIds - 단속 아이디 리스트</li></ul>
	 * @return 단속, 납부자 객체
	 */
	List<DataObject> selectCrdnList(Map<String, Object> params);

	default List<DataObject> selectCrdnList(Iterable<String> crdnIds) {
		return selectCrdnList(Map.of("crdnIds", crdnIds));
	}

	/**단속 ID에 해당하는 단속, 납부자 객체를 반환한다.
	 * @param crdnId 단속 ID
	 * @return 단속, 납부자 객체
	 */
	default DataObject selectCrdnInfo(String crdnId) {
		List<DataObject> list = selectCrdnList(List.of(crdnId));
		return !list.isEmpty() ? list.get(0) : null;
	}
}